﻿from microcontroleurs import arduino
import matplotlib.pyplot as plt
import numpy as np

#creation de la commuication avec la carte arduino
#le numero du port COM est à modifier
macarte = arduino("COM35")

#crée deux listes vides pour mettre les mesures
volume = []
invP = []

#demande à l'utilisateur le nb de points de mesure
nb_points=int(input("Entrez le nombre de points de mesure :"))

#remplit les listes avec les valeurs
for i in range(nb_points):
    #ajoute le volume entre par l'utilisateur dans la liste
    volume.append(int(input("Entrez le volume en cm3 :")))
    #ajoute 1/P mesuree par le capteur à la liste
    tension=macarte.entree_analogique(0) * 5 / 1023
    invP.append(1/(498.6*tension + 116))

#arret de la communication avec la carte arduino
macarte.fermer()
print(volume)
print(invP)
#equation de la caractéristique
modele=np.polyfit(invP,volume,1)
print("volume = ",modele[0]," x 1/P + ",modele[1])

# trace la courbe pression en fonction de la tension
plt.plot(invP,volume, marker="+")
plt.title("volume = f(1/P)")
plt.xlabel("1/P (hPa-1)")
plt.ylabel("volume (cm3)")
plt.show()



